;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
; UBIOS FUNCTIONS
;
BF_CIO		.EQU	$10
BF_CIOIN	.EQU	BF_CIO + 1	; CHARACTER INPUT
BF_CIOOUT	.EQU	BF_CIO + 2	; CHARACTER OUTPUT
BF_CIOIST	.EQU	BF_CIO + 3	; CHARACTER INPUT STATUS
BF_CIOOST	.EQU	BF_CIO + 4	; CHARACTER OUTPUT STATUS
;
BF_DIO		.EQU	$40
BF_DIOREAD	.EQU	BF_DIO + 2	; DISK READ
BF_DIOWRITE	.EQU	BF_DIO + 3	; DISK WRITE
;
; MEMORY BANK CONFIGURATION
;
ROMSIZE		.EQU	512
RAMSIZE		.EQU	512

BID_ROM0	.EQU	$0000
BID_ROMN	.EQU	(BID_ROM0 + ((ROMSIZE / 32) - 1))
BID_RAM0	.EQU	$8000
BID_RAMN	.EQU	(BID_RAM0 + ((RAMSIZE / 32) - 1))

BID_BOOT	.EQU	BID_ROM0	; BOOT BANK
BID_BIOSIMG	.EQU	BID_ROM0 + 1	; BIOS IMAGE BANK
BID_OSIMG	.EQU	BID_ROM0 + 2	; ROM LOADER AND IMAGES BANK
BID_FSFAT	.EQU	BID_ROM0 + 3	; FAT FILESYSTEM DRIVER BANK
BID_ROMD0	.EQU	BID_ROM0 + 4	; FIRST ROM DRIVE BANK
BID_ROMDN	.EQU	BID_ROMN	; LAST ROM DRIVE BANK

BID_RAMD0	.EQU	BID_RAM0	; FIRST RAM DRIVE BANK
BID_RAMDN	.EQU	BID_RAMN - 4	; LAST RAM DRIVE BANK
BID_AUX		.EQU	BID_RAMN - 3	; AUX BANK (BPBIOS, ETC.)
BID_BIOS	.EQU	BID_RAMN - 2	; BIOS BANK
BID_USR		.EQU	BID_RAMN - 1	; USER BANK (CP/M TPA, ETC.)
BID_COM		.EQU	BID_RAMN	; COMMON BANK, UPPER 32K
